<div>
    <div class="light-border-spacing">
        <div v-if="newest_tab!=undefined">
            <div class="title-spinner">
                <h4 class="title-bc">
                    CURRENT HEAD CONSENSUS OPERATIONS
                    <b-button
                        @click="freeze = !freeze"
                        :pressed="freeze"
                        class="mx-2"
                        variant="dark"
                        tabindex="-1"
                    >
                        <!-- This is equivalent in theory to:
                             <i class="bi bi-snow2"></i> -->
                        <svg
                            src="/img/snow2.svg"
                            width="16"
                            height="16"
                            viewBox="0 0 16 16"
                            fill="currentColor"
                            class="bi"
                        >
                            <path
                                d="M8 16a.5.5 0 0 1-.5-.5v-1.293l-.646.647a.5.5 0 0 1-.707-.708L7.5 12.793v-1.086l-.646.647a.5.5 0 0 1-.707-.708L7.5 10.293V8.866l-1.236.713-.495 1.85a.5.5 0 1 1-.966-.26l.237-.882-.94.542-.496 1.85a.5.5 0 1 1-.966-.26l.237-.882-1.12.646a.5.5 0 0 1-.5-.866l1.12-.646-.884-.237a.5.5 0 1 1 .26-.966l1.848.495.94-.542-.882-.237a.5.5 0 1 1 .258-.966l1.85.495L7 8l-1.236-.713-1.849.495a.5.5 0 1 1-.258-.966l.883-.237-.94-.542-1.85.495a.5.5 0 0 1-.258-.966l.883-.237-1.12-.646a.5.5 0 1 1 .5-.866l1.12.646-.237-.883a.5.5 0 0 1 .966-.258l.495 1.849.94.542-.236-.883a.5.5 0 0 1 .966-.258l.495 1.849 1.236.713V5.707L6.147 4.354a.5.5 0 1 1 .707-.708l.646.647V3.207L6.147 1.854a.5.5 0 1 1 .707-.708l.646.647V.5a.5.5 0 0 1 1 0v1.293l.647-.647a.5.5 0 1 1 .707.708L8.5 3.207v1.086l.647-.647a.5.5 0 1 1 .707.708L8.5 5.707v1.427l1.236-.713.495-1.85a.5.5 0 1 1 .966.26l-.236.882.94-.542.495-1.85a.5.5 0 1 1 .966.26l-.236.882 1.12-.646a.5.5 0 0 1 .5.866l-1.12.646.883.237a.5.5 0 1 1-.26.966l-1.848-.495-.94.542.883.237a.5.5 0 1 1-.26.966l-1.848-.495L9 8l1.236.713 1.849-.495a.5.5 0 0 1 .259.966l-.883.237.94.542 1.849-.495a.5.5 0 0 1 .259.966l-.883.237 1.12.646a.5.5 0 0 1-.5.866l-1.12-.646.236.883a.5.5 0 1 1-.966.258l-.495-1.849-.94-.542.236.883a.5.5 0 0 1-.966.258L9.736 9.58 8.5 8.866v1.427l1.354 1.353a.5.5 0 0 1-.707.708l-.647-.647v1.086l1.354 1.353a.5.5 0 0 1-.707.708l-.647-.647V15.5a.5.5 0 0 1-.5.5"
                            />
                        </svg>
                    </b-button>
                </h4>
            </div>
            <div class="table-responsive" style="max-height: 800px">
                <table
                    class="w-100 d-block d-table table-striped table-hover table-sm th-sticky-top"
                >
                    <thead>
                        <tr>
                            <th>
                                <div class="centered-header">
                                    <span style="white-space: nowrap">Baker → slots</span>
                                </div>
                            </th>
                            <th>
                                <div class="centered-header">
                                    <span id="newest_tab_prattes_ts"
                                        >Consensus pre-attestations</span
                                    >
                                    <span>
                                        weight → {{newest_tab.voting_state.preattestation.counter}}
                                        ({{newest_tab.voting_state.preattestation.percent_progression}}%)
                                    </span>
                                </div>
                            </th>
                            <th>
                                <div class="centered-header">
                                    <span id="newest_tab_attes_ts">Consensus attestations</span>
                                    <span>
                                        weight → {{newest_tab.voting_state.attestation.counter}}
                                        ({{newest_tab.voting_state.attestation.percent_progression}}%)
                                    </span>
                                </div>
                            </th>
                            <th v-if="dal_enabled">
                                <div class="centered-header">
                                    <span>DAL attested/total published slots</span>
                                </div>
                            </th>
                            <b-tooltip
                                target="newest_tab_prattes_ts"
                                placement="top"
                                boundary="window"
                                custom-class="cops-hd-tooltip"
                                triggers="hover"
                            >
                                <div class="alert alert-secondary" role="alert">
                                    <p class="justified">
                                        Time elapsed between the moment the operation was fetched by
                                        the current node address/api and the time the block was
                                        proposed.
                                    </p>
                                </div>
                            </b-tooltip>
                            <b-tooltip
                                target="newest_tab_attes_ts"
                                boundary="window"
                                placement="top"
                                custom-class="cops-hd-tooltip"
                                triggers="hover"
                            >
                                <div class="alert alert-secondary" role="alert">
                                    <p class="justified">
                                        Time elapsed between the moment the operation was fetched by
                                        the current node address/api and the time the block was
                                        proposed.
                                    </p>
                                </div>
                            </b-tooltip>
                        </tr>
                    </thead>
                    <tbody>
                        <template
                            v-for="[baker, [baker_info, operations]] in newest_tab.baker_tabs"
                        >
                            <tr v-if="baker_info.is_missing" class="line-through">
                                <td>
                                    <div class="center">
                                        <v-hash
                                            v-bind:hash="baker"
                                            category="account"
                                            class="text-nowrap"
                                            v-slot="{ shorten_hash }"
                                        >
                                            <b>{{ shorten_hash }}</b>
                                        </v-hash>
                                        &nbsp;→ {{baker_info.attesting_power}}
                                        ({{baker_info.attesting_power_percent}}%)
                                    </div>
                                </td>
                                <td />
                                <td />
                                <td v-if="dal_enabled" />
                            </tr>
                            <tr v-else>
                                <td>
                                    <div class="center text-nowrap">
                                        <v-hash
                                            v-bind:hash="baker"
                                            category="account"
                                            class="text-nowrap"
                                            v-slot="{ shorten_hash }"
                                        >
                                            <b>{{ shorten_hash }}</b>
                                        </v-hash>
                                        &nbsp;→ {{baker_info.attesting_power}}
                                        ({{baker_info.attesting_power_percent}}%)
                                    </div>
                                </td>
                                <td v-if="operations.preattestation.length === 0">
                                    <div class="center">
                                        <i
                                            v-if="protocol_transition_level===newest_tab.level"
                                            class="bi bi-x-circle-fill"
                                        />
                                        <i v-else class="bi bi-eye-slash-fill" />
                                    </div>
                                </td>
                                <td v-else-if="operations.preattestation.length === 1">
                                    <div class="center text-nowrap">
                                        <div
                                            v-for="[hash, preattestation] in operations.preattestation"
                                            class="inline-left"
                                        >
                                            <v-hash
                                                v-bind:hash="hash"
                                                v-bind:class="[{'text-blue' : preattestation.status === 'Applied'},
							  {'text-orange' : preattestation.status === 'Outdated'}]"
                                                category="hash"
                                            >
                                            </v-hash>
                                            <span v-if="preattestation.delta!=undefined">
                                                &nbsp;({{preattestation.delta}}s)
                                            </span>
                                        </div>
                                    </div>
                                </td>
                                <td v-else>
                                    <div class="center text-nowrap">
                                        <ul class="no-margin-padding inline-block-ul text-red">
                                            <li
                                                v-for="[hash, preattestation] in operations.preattestation"
                                            >
                                                <div class="inline-left">
                                                    <v-hash v-bind:hash="hash" category="hash">
                                                    </v-hash>
                                                    <span v-if="preattestation.delta!=undefined">
                                                        &nbsp;({{preattestation.delta}}s)
                                                    </span>
                                                </div>
                                            </li>
                                        </ul>
                                    </div>
                                </td>
                                <td v-if="operations.attestation.length === 0">
                                    <div class="center">
                                        <i
                                            v-if="protocol_transition_level===newest_tab.level"
                                            class="bi bi-x-circle-fill"
                                        />
                                        <i v-else class="bi bi-eye-slash-fill" />
                                    </div>
                                </td>
                                <td v-else-if="operations.attestation.length === 1">
                                    <div class="center text-nowrap">
                                        <div
                                            v-for="[hash, attestation] in operations.attestation"
                                            class="inline-left"
                                        >
                                            <v-hash
                                                v-bind:hash="hash"
                                                v-bind:class="[{'text-blue' : attestation.status === 'Applied'},
							  {'text-orange' : attestation.status === 'Outdated'}]"
                                                category="hash"
                                            >
                                            </v-hash>
                                            <span v-if="attestation.delta!=undefined">
                                                &nbsp;({{attestation.delta}}s)
                                            </span>
                                        </div>
                                    </div>
                                </td>
                                <td v-else>
                                    <div class="center text-nowrap">
                                        <ul class="no-margin-padding inline-block-ul text-red">
                                            <li
                                                v-for="[hash, attestation] in operations.attestation"
                                            >
                                                <div class="inline-left">
                                                    <v-hash v-bind:hash="hash" category="hash">
                                                    </v-hash>
                                                    <span v-if="attestation.delta!=undefined">
                                                        &nbsp;({{attestation.delta}}s)
                                                    </span>
                                                </div>
                                            </li>
                                        </ul>
                                    </div>
                                </td>
                                <template v-if="dal_enabled">
                                    <td v-if="operations.attestation.length === 0">
                                        <div class="center">
                                            <i
                                                v-if="protocol_transition_level===newest_tab.level"
                                                class="bi bi-x-circle-fill"
                                            />
                                            <i
                                                v-else
                                                class="bi bi-file-earmark-x-fill no-margin-padding"
                                            />
                                        </div>
                                    </td>
                                    <td v-else-if="operations.attestation.length === 1">
                                        <div class="center text-nowrap">
                                            <div
                                                v-for="[hash, attestation] in operations.attestation"
                                            >
                                                <span
                                                    :id="'dal_ratio_' + hash"
                                                    v-if="attestation.dal!=undefined"
                                                    v-bind:class="[{'text-darkorange' : attestation.dal.unknown_commitment_attested}]"
                                                >
                                                    {{attestation.dal.attested_slots}} /
                                                    {{newest_tab.total_commitment_slots}}
                                                </span>
                                                <i
                                                    v-else
                                                    class="bi bi-file-earmark-x-fill no-margin-padding"
                                                />
                                                <template v-if="attestation.dal!=undefined">
                                                    <b-tooltip
                                                        v-if="attestation.dal.total_slots!=0"
                                                        :target="'dal_ratio_' + hash"
                                                        placement="right"
                                                        boundary="window"
                                                        custom-class="dal-tooltip"
                                                        triggers="hover"
                                                    >
                                                        <div
                                                            class="alert alert-secondary"
                                                            role="alert"
                                                        >
                                                            <p style="color: green">
                                                                <template
                                                                    v-for="[index, status] in attestation.dal.attested_slot_index"
                                                                >
                                                                    <template
                                                                        v-if="status.Known_commitment!=undefined
									    && status.Known_commitment"
                                                                    >
                                                                        {{index}}&nbsp
                                                                    </template>
                                                                </template>
                                                            </p>
                                                            <p style="color: red">
                                                                <template
                                                                    v-for="[index, status] in attestation.dal.attested_slot_index"
                                                                >
                                                                    <template
                                                                        v-if="status.Known_commitment!=undefined
									    && !status.Known_commitment"
                                                                    >
                                                                        {{index}}&nbsp
                                                                    </template>
                                                                </template>
                                                            </p>
                                                            <p
                                                                v-if="attestation.dal.unknown_commitment_attested"
                                                                style="color: darkorange"
                                                            >
                                                                <template
                                                                    v-for="[index, status] in attestation.dal.attested_slot_index"
                                                                >
                                                                    <template
                                                                        v-if="status.Unknown_commitment_attested!=undefined"
                                                                    >
                                                                        {{index}}&nbsp
                                                                    </template>
                                                                </template>
                                                            </p>
                                                        </div>
                                                    </b-tooltip>
                                                </template>
                                            </div>
                                        </div>
                                    </td>
                                    <td v-else>
                                        <div class="center text-nowrap">
                                            <ul class="no-margin-padding inline-block-ul text-red">
                                                <li
                                                    v-for="[hash, attestation] in operations.attestation"
                                                >
                                                    <span
                                                        id="dal_ratio"
                                                        v-if="attestation.dal!=undefined"
                                                    >
                                                        {{attestation.dal.attested_slots}} /
                                                        {{attestation.dal.total_slots}}
                                                    </span>
                                                </li>
                                            </ul>
                                        </div>
                                    </td>
                                </template>
                            </tr>
                        </template>
                    </tbody>
                </table>
            </div>
        </div>
        <div v-else>
            <div class="title-spinner">
                <h4 class="title-bc">
                    CURRENT HEAD CONSENSUS OPERATIONS
                    <b-spinner v-if="baking_rights===undefined" class="spaced-spinner"></b-spinner>
                </h4>
            </div>
            <div class="table-responsive-xl">
                <table class="table table-sm table-striped table-hover">
                    <thead>
                        <tr>
                            <th>Baker → slots (%)</th>
                            <th>Pre-attestations</th>
                            <th>Attestations</th>
                        </tr>
                    </thead>
                    <tbody v-if="consensus_ops===undefined">
                        <tr v-for="i in 20">
                            <td style="height: 50px"></td>
                            <td style="height: 50px"></td>
                            <td style="height: 50px"></td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
        <div v-if="other_tabs!=undefined && other_tabs.all_level_round.length">
            <div class="title-spinner">
                <h4 class="title-bc">OLD BLOCKS CONSENSUS OPERATIONS</h4>
            </div>
            <div class="table-responsive" style="max-height: 800px">
                <table
                    class="w-100 table-striped table-hover table-sm table-striped table-hover consensus-ops-table cell-min-width th-sticky-left th-sticky-top"
                >
                    <thead>
                        <tr>
                            <th class="centered-text table-corner border-top" style="width: 10%">
                                Level →
                            </th>
                            <th
                                v-for="[level, all_round] in other_tabs.all_level_round"
                                v-bind:colspan="2 * all_round.length"
                                scope="group"
                                class="centered-text border-top"
                            >
                                <span>{{level}}</span>
                                <span v-if="protocol_transition_level===level">
                                    &nbsp;Protocol transition
                                </span>
                            </th>
                        </tr>
                        <tr>
                            <th class="centered-text table-corner border-mid">Round →</th>
                            <template v-for="[level, all_round] in other_tabs.all_level_round">
                                <th
                                    v-for="round in all_round"
                                    colspan="2"
                                    class="centered-text border-mid"
                                >
                                    {{round}}
                                </th>
                            </template>
                        </tr>
                        <tr>
                            <th class="centered-text table-corner border-bot">Approval →</th>
                            <template v-for="[level, all_round] in other_tabs.all_level_round">
                                <template v-for="round in all_round">
                                    <th class="centered-text border-bot-L">Preattestations</th>
                                    <th class="centered-text border-bot-R">Attestations</th>
                                </template>
                            </template>
                        </tr>
                    </thead>
                    <tbody>
                        <template
                            v-for="[baker, [baker_info, levels_rounds_operations]] in other_tabs.baker_tabs"
                        >
                            <tr v-if="baker_info.is_missing" class="line-through">
                                <th>
                                    <v-hash
                                        v-bind:hash="baker"
                                        category="account"
                                        class="center text-nowrap"
                                    >
                                    </v-hash>
                                </th>
                                <template v-for="[level, rounds] in levels_rounds_operations">
                                    <template
                                        v-for="[round, operations] in
                                           rounds"
                                    >
                                        <td />
                                        <td />
                                    </template>
                                </template>
                            </tr>
                            <tr v-else>
                                <th>
                                    <v-hash
                                        v-bind:hash="baker"
                                        category="account"
                                        class="center text-nowrap"
                                    >
                                    </v-hash>
                                </th>
                                <template v-for="[level, rounds] in levels_rounds_operations">
                                    <template
                                        v-for="[round, operations] in
                                           rounds"
                                    >
                                        <td
                                            v-if="operations.preattestation.length === 0"
                                            class="centered-text"
                                        >
                                            <i
                                                v-if="protocol_transition_level===level"
                                                class="bi bi-x-circle-fill"
                                            />
                                            <i v-else class="bi bi-eye-slash-fill" />
                                        </td>
                                        <td v-else-if="operations.preattestation.length === 1">
                                            <v-hash
                                                v-for="[hash, preattestation] in operations.preattestation"
                                                v-bind:hash="hash"
                                                category="hash"
                                                v-bind:class="[{'text-blue' : preattestation.status === 'Applied'},
							      {'text-orange' : preattestation.status === 'Outdated'},
							      'center']"
                                            >
                                            </v-hash>
                                        </td>
                                        <td v-else>
                                            <div class="center">
                                                <ul class="no-margin-padding inline-ul text-red">
                                                    <li
                                                        v-for="[hash, preattestation] in operations.preattestation"
                                                    >
                                                        <v-hash v-bind:hash="hash" category="hash">
                                                        </v-hash>
                                                    </li>
                                                </ul>
                                            </div>
                                        </td>
                                        <td
                                            v-if="operations.attestation.length === 0"
                                            class="centered-text"
                                        >
                                            <i
                                                v-if="protocol_transition_level===level"
                                                class="bi bi-x-circle-fill"
                                            />
                                            <i v-else class="bi bi-eye-slash-fill" />
                                        </td>
                                        <td v-else-if="operations.attestation.length === 1">
                                            <v-hash
                                                v-for="[hash, attestation] in operations.attestation"
                                                v-bind:hash="hash"
                                                category="hash"
                                                v-bind:class="[{'text-blue' : attestation.status === 'Applied'},
							      {'text-orange' : attestation.status === 'Outdated'},
							      'center']"
                                            >
                                            </v-hash>
                                        </td>
                                        <td v-else>
                                            <div class="center">
                                                <ul class="no-margin-padding inline-ul text-red">
                                                    <li
                                                        v-for="[hash, attestation] in operations.attestation"
                                                    >
                                                        <v-hash v-bind:hash="hash" category="hash">
                                                        </v-hash>
                                                    </li>
                                                </ul>
                                            </div>
                                        </td>
                                    </template>
                                </template>
                            </tr>
                        </template>
                    </tbody>
                </table>
            </div>
        </div>
        <div class="center legend-table">
            <div class="centered-text">
                <span class="small-legend-size text-blue">Applied operations</span>
            </div>
            <div class="centered-text">
                <span class="small-legend-size text-orange">Oudated operations</span>
            </div>
            <div class="centered-text">
                <span class="small-legend-size text-red">Multiple operations</span>
            </div>
            <div class="centered-text">
                <span class="small-legend-size line">Missing baker</span>
            </div>
            <div class="centered-text">
                <span class="small-legend-size">
                    <i class="bi bi-eye-slash-fill"></i> Already included or unseen operations
                </span>
            </div>
            <div class="centered-text">
                <span class="small-legend-size">
                    <i class="bi bi-x-circle-fill" /> No operations due to protocol injection
                </span>
            </div>
            <div class="centered-text">
                <span class="small-legend-size">
                    <i class="bi bi-file-earmark-x-fill" /> No DAL attestation seen
                </span>
            </div>
        </div>
    </div>
</div>
